/**
 * pigaiSpeech(mui, '#pigai-speech' ,{ cb:function(s){}})
 * @param {Object} $
 * @param {Object} qSelector
 */
function pigaiSpeech( $,qSelector ){
	var conf={
		'cuid':'1984449',
		'apiKey':'KInKrg62WWANCeaqzEv6pvfEUE86tMhx',
		'secretKey':'64ZHAHS32W8dqF41vuYqGFWxNdNqjTEh'
		,cb:function(){}
		,startTimestamp:0
		,recorder:null
		,recorderCannel:false
		,times:0
	}
	if( arguments.length>2) $.extend( conf, arguments[2] );
	var ui= document.querySelectorAll( qSelector );
	function baiduToken( cb ){
		var url = 'https://openapi.baidu.com/oauth/2.0/token?grant_type=client_credentials&client_id='+conf.apiKey+'&client_secret='+ conf.secretKey;
		$.ajax({ 
			url: url,
			'dataType':'json', 
			success:function(rep){					 
				 cb( rep );
			},error:function(){
				app.closeWaiting();
				msg("token 错误！");
			}
		});	
	}
	
	function loadPigaiConf(){ 
		var url ='?c=api&a=pigaispeech';
		app.ajax({
     			url:url
     			,success:function(data){
     				$.extend( conf, data.data );
     				//console.log( JSON.stringify( data));  
				}
     	});     
	}
	
	function baiduSpeech( path ){
		//msg("马上打分了");
		app.showWaiting('正在识别');
		//console.error( Base64.encode( 'I am  a good student') );
		
		var baiduSpeechDa= function(rep,rz){
			
			rz.data = rz.data.replace('data:audio/amr;base64,','');			
			var data={format:'amr',rate:8000, channel:1,lan:'en',token:rep.access_token,cuid:conf.cuid };			
			data.len= rz.size; 
			data.speech = rz.data ;  
			 
			var url= 'http://vop.baidu.com/server_api';
			
			$.ajax(url ,{ 
				 
				headers:{'Content-Type':'application/json; charset=utf-8'},
				type:'post',
				'dataType':'json',
				'data': data ,				 
				success:function(rp ){	
					app.closeWaiting();
					//console.error( JSON.stringify(rp ) );	
					if( rp.err_no!=0){
						msg("错误："+ rp.err_msg );
						return false ;
					}
					conf.cb( rp.result );
				},
				error:function( e ){
					app.closeWaiting();
					msg('error 识别');  
				}
		});	
		}
		
		// 可通过fs进行文件操作
		plus.io.resolveLocalFileSystemURL( path , function( entry  ) {		 
			
			entry.file( function(file){
				var fileReader = new plus.io.FileReader();
				//alert("getFile:" + JSON.stringify(file));
				//fileReader.readAsText(file);//, 'utf-8'
				fileReader.readAsDataURL(file);//, 'utf-8' 
				fileReader.onloadend = function(evt) { 
					var rz ={data:  evt.target.result ,size: file.size  };
					baiduToken( function(rep){
						baiduSpeechDa(rep, rz );
					});
				}
				 
			});				
				
			}, function ( e ) {
				msg( "发生错误: " + e.message );
		});
	
	}
	
	function speechUi(){
		//app.showWaiting("请说话，倾听中");
		for(var i=0; i<ui.length;i++ ){
			ui[i].addEventListener( 'hold',recodeStart,false);
			ui[i].addEventListener( 'release',recodeEnd ,false);
			//console.error("style2:[ "+ui[i].style.bottom +","+ ui[i].style.right +"]");
			//drap( ui[i]);
		 
			 
		}
	}
	function drap( obj ){
		var dconf={} 
		obj.draggable= true; 
		console.log("style:[ "+obj.style.left+","+ obj.style.top+"]");
		obj.addEventListener( 'drag',function(e){
			//console.log("drag:["+ e.detail.deltaX+","+e.detail.deltaY+ "]\t [ "+obj.style.bottom+","+ obj.style.right+"]");
			obj.style.bottom= ( dconf.bottom-e.detail.deltaY)+'px'; 
			obj.style.right= ( dconf.right-e.detail.deltaX)+'px';
		} ,false);
		
		obj.addEventListener( 'dragend',function(e){ 
			console.log("end") 
		} ,false);
		
		obj.addEventListener( 'dragstart',function(e){ 
			dconf.bottom= parseInt( obj.style.bottom);
			dconf.right= parseInt( obj.style.right);
			console.log("start:"+ JSON.stringify(dconf )); 
		} ,false);
	}
	function recodeDrapStart( obj ){
		 
	}
	function recodeDrap( e ){		
		//console.log("xy:"+ e.detail.deltaX+","+e.detail.deltaY); //
		for( p in  e.detail ){
			console.log("drop:"+ p );
		}
	}
	function recodeStart(){
		
		var recorder = conf.recorder ? conf.recorder: plus.audio.getRecorder();
		if (recorder == null) {
			msg("不能获取录音对象");
			return;
		}
		recorder.record({
				filename: "_doc/audio/",
				format:"amr"
		}, function(path) {	
			
			//console.error( 'path:'+ path ); 
			
			var sptime= ((new Date()).getTime()-conf.startTimestamp)/1000;
			if(sptime<1 ){
				msg("长按录音时间不小于1秒");				 
				return false ;
			}
			conf.times=-10;
			//msg( "时间："+ sptime+ " s");
			baiduSpeech(  path );
		}, function(e) {
			app.closeWaiting();
			msg("录音时出现异常: " + e.message  ); 
		});
		conf.recorder= recorder;
		//if() app.showWaiting("长按录音");
		app.msg("长按录音，放开识别");
		conf.startTimestamp= (new Date()).getTime();
		var timeStop= function(){
			if( conf.times <0 ) return ;
			console.log('times:'+ conf.times );
			conf.times++;
			if( conf.times>=10){
				recodeEnd();
				return false;
			}
			setTimeout(timeStop,1000 );			
		}
		conf.times=0;
		timeStop(); 
		 
	}
	function msg( str ){
		plus.nativeUI.toast(str);
	}
	function recodeEnd(){
		console.log('结束了');
		//alert('ddd');
		app.closeWaiting();
		if( conf.recorder!=null ) conf.recorder.stop();
		 
	}
	function start(){
		loadPigaiConf();
		speechUi();
	}
	start();
}


function pigaiSpeechV2( path ){
	var conf={
		'cuid':'1984449',
		'apiKey':'KInKrg62WWANCeaqzEv6pvfEUE86tMhx',
		'secretKey':'64ZHAHS32W8dqF41vuYqGFWxNdNqjTEh'
		,cb:function(){}
		,startTimestamp:0
		,recorder:null
		,recorderCannel:false
		,times:0
	}
	
	if( arguments.length>1) mui.extend( conf, arguments[1] );
	
	var doStart= function(){
		app.showWaiting('正在识别');
		// 可通过fs进行文件操作
		plus.io.resolveLocalFileSystemURL( path , function( entry  ) {		 
			
			entry.file( function(file){
				var fileReader = new plus.io.FileReader();
				//alert("getFile:" + JSON.stringify(file));
				//fileReader.readAsText(file);//, 'utf-8'
				fileReader.readAsDataURL(file);//, 'utf-8' 
				fileReader.onloadend = function(evt) { 
					var rz ={data:  evt.target.result ,size: file.size  };
					baiduToken( function(rep){
						baiduSpeechDa(rep, rz );
					});
				}
				 
			});				
				
			}, function ( e ) {
				msg( "发生错误: " + e.message );
				app.closeWaiting();
		});
	}
	var baiduSpeechDa= function(rep,rz){
			
			rz.data = rz.data.replace('data:audio/amr;base64,','');			
			var data={format:'amr',rate:8000, channel:1,lan:'en',token:rep.access_token,cuid:conf.cuid };			
			data.len= rz.size; 
			data.speech = rz.data ;  
			 
			var url= 'http://vop.baidu.com/server_api';
			
			mui.ajax(url ,{ 
				 
				headers:{'Content-Type':'application/json; charset=utf-8'},
				type:'post',
				'dataType':'json',
				'data': data ,				 
				success:function(rp ){	
					app.closeWaiting();
					//console.error( JSON.stringify(rp ) );	
					if( rp.err_no!=0){
						msg("错误："+ rp.err_msg );
						return false ;
					}
					conf.cb( rp.result );
				},
				error:function( e ){
					app.closeWaiting();
					msg('error 识别');  
				}
		});	
	}
	
	var baiduToken = function ( cb ){
		var url = 'https://openapi.baidu.com/oauth/2.0/token?grant_type=client_credentials&client_id='+conf.apiKey+'&client_secret='+ conf.secretKey;
		mui.ajax({ 
			url: url,
			'dataType':'json', 
			success:function(rep){					 
				 cb( rep );
			},error:function(){
				app.closeWaiting();
				msg("token 错误！");
			}
		});	
	}
	
	doStart();
}
