(function($,owner){
	owner.me = null;
	
	owner.getMe= function(){
		if(owner.me!=null ) return owner.me;
		owner.me= owner.getState();
		return owner.me;
	}
	
	owner.getServer= function(){
		//if( typeof plus == 'undefined')		return '/';
		return 'http://pgclient.pigai.org/';
	}

	
	owner.login= function(data){
		var config={
			'account':'',
			'password':'',
			'cb':function () {}
		}
		$.extend( config,data );
		if(config.account==''){
			owner.msg("请填入账号！");
			return false;
		}
		if(config.password  ==''){
			owner.msg("请填入密码！");
			return false;
		}
		//owner.msg( '正在登录...');
		 plus.nativeUI.showWaiting( "正在登录..." );
		
		//var url= getServer()+'chat/login.php';
		//var url= getServer()+'tp/chat/user/login';
		var url= getServer()+'/?c=api&a=sentbase&action=login&key=SE9mpdwTPxyKGUvJb9vrVfYlwX803YcH&type=json';
		$.ajax( url ,{
			data:{'email': config.account,'psw' : config.password },
			dataType:'json',//服务器返回json格式数据
			type:'post',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
				
				owner.log( JSON.stringify( data ) );
				if( data.error>0 ){
					owner.msg(  data.error_des );
					plus.nativeUI.closeWaiting();
					return false; 
				}
				owner.setState(  data.data  );
				owner.registIcomet(  config );
				 
				
			},
			error:function(xhr,type,errorThrown){
				plus.nativeUI.closeWaiting();
				 owner.msg( "发送错误！");
				 owner.log( type );
				  
			}
		});
		return false; 
		
		
	}
	
	owner.registIcomet= function(  config ){
		var url= getServer()+'chat/login.php';
		$.ajax( url ,{
			data:{'uname': config.account  },
			//dataType:'json',//服务器返回json格式数据
			type:'post',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
				//owner.log( "请求到达数据："+ data  );
				//owner.setState(  {'uname': cname} );
				plus.nativeUI.closeWaiting();
				owner.msg( '登录成功！');				
				config.cb();
				
				//callback();
			},
			error:function(xhr,type,errorThrown){
				plus.nativeUI.closeWaiting();
				 owner.msg( "发送错误！");
				 owner.log( type );
				  
			}
		});
	}
	
	owner.msg= function(str ){
		try{
			plus.nativeUI.toast( str );
		}catch(e){
			alert(str);
		}
		//console.warn("app-msg："+ str);
		//owner.log(str);
	}
	owner.log= function( str ){
		try{
		 //console.error("app log:"+ str);
		}catch(e ){
			
		}
		console.log( "app log:"+ str );
	}
	
	
	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		//owner.log(stateText);
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));		 
	};
	
	owner.save= function(key,obj){
		obj= obj ||{};	
		localStorage.setItem( key , JSON.stringify(obj));	
	}
	owner.get= function( key ){
		var str = localStorage.getItem(key ) || "{}";
		return JSON.parse( str );
	}

	owner.checkEmail = function(email) {
		email = email || '';
		return (email.length > 3 && email.indexOf('@') > -1);
	};
	
	owner.backExit = function(){
		var backButtonPress = 0;
		$.back = function(event) {
			backButtonPress++;
			if (backButtonPress > 1) {
				plus.runtime.quit();
			} else {
				plus.nativeUI.toast('再按一次退出应用');
			}
			setTimeout(function() {
				backButtonPress = 0;
			}, 1000);
			return false;
		};
	}
	
	/**
	 * 
	 * @param {String} str
	 * @param {Array} array
	 */
	owner.in_array = function (str, array ){
		for(p in array ){
			if( str == array[p]) return true;
		}
		return false;				
	}
	
	owner.html= function( select){
		var obj= $(select);
		if(obj.length<=0) return false;
		 
	}
	
	owner.listFriend= function(){
		var url= getServer()+'chat/api/contacts.php?type=all';
		var url= getServer()+'tp/chat/user/contacts';
		var config={cb:null };
		var _self = this;
		if(arguments.length>0 ) mui.extend(config,arguments[0]);
		
		$.ajax( url ,{
			data:{},
			dataType:'json',//服务器返回json格式数据
			type:'get',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
				//_self.addRen(data);
				console.log(JSON.stringify(data));
				if(config.cb!=null) config.cb( data );
				if( data.error==0 ) owner.save('usersList', data.data.listSave );
				
			},
			error:function(xhr,type,errorThrown){
				 owner.log(type+" url:"+ url);
			}
	    });
	}
	/**
	 * msg.type =[text|image|sound] 通过这个来表示消息内心
	 * @param {Object} msg
	 */
	owner.sendMsg= function( msg ){
		var url= getServer()+'chat/api/send.php';	
		msg.text= msg.content;
		console.error("sendMsg: "+ JSON.stringify(msg)); 
		$.ajax( url ,{
			data: msg //{	'text':msg.content,		'uid2':msg.uid2			}
			,dataType:'json',//服务器返回json格式数据
			type:'post',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
			},
			error:function(xhr,type,errorThrown){
				//异常处理；
				//if(config.cb!=null) config.cb();
				owner.log("loginerro:"+type+ "\n\nurl:"+ url);
			}
		}); 
		  
		
	}
	
	owner.getUserInfo = function(name){
		
		var u = owner.get( 'usersList');
		console.log(JSON.stringify(u));
		if(u[name]==undefined ) return false;
		return u[name];
	}
	owner.page={};
	owner.page.view=function(rid){
		var conf={
			essay_id:"0",
			essay_type:"0"
		}
	}
	owner.page.write= function( rid ){
		
	}
	
	
}(mui,window.app={} ))
