/**
 * 
 * @param {String} artstr 文章内容 
 */
function pigaiGuest( ){
	var conf={
		$:mui,
		callback:null,		//完成时候的函数 返回  rep.score  rep.score_cat rep.sentences 
		errorFun:null,		//当发生错误之后 rep.error  rep.error_des
		txt:'',				//作文内容
		title:'',			//作文标题
		kpu: '',	//知识点定制
		processFun:null,	//状态执行函数
		pigaiStart:'?c=api&a=pStart', //开始的时候往这个地方抛出数据
		pigaiEnd:'?c=api&a=pEnd', //分析完后从这个地方取数据
		icometServer:'http://open.pigai.org/icomet/', //icomet 服务器
		icometJS:'http://cdn.pigai.org/res/javascript/icomet.js',	//icomet icometJS
		ddd:'good' 
	}
	if(arguments.length>0){
		conf.$.extend(conf, arguments[0]);
	}
	var config= conf;
	
	var perror = function(ierror,ierror_des){
		if( config.errorFun!=null ){
			config.errorFun( {error:ierror,error_des: ierror_des} );				
		}
		log(" error:"+ierror+",error_des"+ierror_des );
	}
	var log = function(str){
		try{
			console.log('[PIGAI] '+ str );
		}catch(e){
		}
	}
	if(  config.txt =='' ){			 
		perror(20401, 'the txt is empty');
		throw "the txt is empty";
		
	}
	if( typeof config.callback  !='function' ){			
		perror(  20402, "the 'callback' is not a function"   ) ;			
		throw "the 'callback' is not a function";
			
	}		

	var done =function(){ 
		var $channel = 'G_' + randomString(30) ; 
		processStar( $channel );
		 
		
	}
	var processStat= function( b_prs){
		if( config.processFun !=null){
			if( b_prs>=0 ){
				config.processFun( b_prs  );
			}
			log('process: '+ b_prs +' %');
		}
	}
	var processStar= function( key ){
		var comet = new iComet({
			channel: key ,
			signUrl: config.icometServer+'sign',
			subUrl: config.icometServer+'sub',
			callback: function(content){ 			
				try{
					eval("var obj="+content+";");
					if( typeof  obj.finished !='undefined' ){ //完成
						comet.stop2(); 
						log('commet stop');
						processStat( 100 );
						processEnd(  key ); 
					}else if( config.processFun !=null) {
						var b_prs = getBar(obj);
						processStat( b_prs );							
					}

				}catch(e){
					log('icomet callback error: '+ e.message );
				} 
			},
			sign_fun:function( content ){  realDone( key ) ; }
		});
	}
	var processEnd=function( key ){
		log('processEnd and Get pigai report start: '+ key );
		var data={'key':key};
		app.ajax({
			url:config.pigaiEnd,
			data:data,
			success:function( rep ){
				config.callback( rep );
			}
		});
		/*
		$.ajax({
			url:  config.pigaiEnd,
			data: data,
			dataType: 'jsonp'
			,error:function(){ perror(20403,'please check config pigaiEnd');}
			,success: function(rep) {
				log('Get pigai report over' );
				if( typeof rep.error !='undefined' ){
					log('Get pigai report over: error '+ rep.error+":"+rep.error_des );
					if( config.processFun != null ) config.processFun( rep );
				}else{
					config.callback( rep );
				}
			}
		});
		*/

	}
	var realDone= function( key ){

		var data={'key':key, "title":  (config.title),"comcontext": (config.txt), 'kpu': (config.kpu)};
		log('realDone Start' );
		app.ajax({
			url:config.pigaiStart,
			data:data,
			success:function( rep ){
			}
		});
		
	}
	
	var randomString = function (len) {
	　　len = len || 15 ;
		var $chars = 'abcdefhijkmnprstwxyz2345678';  
		var maxPos = $chars.length;
		var pwd = '';
		for (i = 0; i < len; i++) {
			pwd += $chars.charAt(Math.floor(Math.random() * maxPos));
		}
		return pwd;
	}

	var getBar = function ( obj ){
		try{
			var s = parseInt( 100*obj.cur/obj.sc );
			return s;
		}catch(e ){
			return -1;
		}
		return -1;

	}
	
	done();
	
}
